【leetcode】【53】Maximum Subarray

一、问题描述

Find the contiguous subarray within an array (containing at least one number) which has the largest sum.

For example, given the array [−2,1,−3,4,−1,2,1,−5,4],
the contiguous subarray [4,−1,2,1] has the largest sum = 6.

click to show more practice.

More practice:

If you have figured out the O(n) solution, try coding another solution using the divide and conquer approach, which is more subtle.

二、问题分析

最大最长连续子序列,非常经典的dynamic programing问题。需要明确的是状态转移方程中的状态代表的含义。因为contiguous,所以dp[i]代表的应该以i位置元素结尾的连续值,并非最大值。

三、Java AC代码

public int maxSubArray(int[] nums) {
        int[] dp = new int[nums.length];
		int max = nums[0];
		dp[0] = nums[0];
		for(int i=1;i
因为很多中间状态是没用的,因此可以用变量代表状态,因此还可以优化。

public int maxSubArray(int[] nums) {
        int maxSoFar = Integer.MIN_VALUE;
		int maxEndingHere = 0;
		for(int i=0;i




你可能感兴趣的:(算法,Java)